#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif


#include "callbacks.h"
#include "interface.h"
#include "engine.h"
#include "wpref.h"


// Zamkniecie aplikacji
void on_MainWindow_destroy(GtkObject * object, gpointer user_data)
{
	gtk_main_quit ();
}


// Zamkniecie aplikacji
void on_wm_quit1_activate(GtkMenuItem * menuitem, gpointer user_data)
{
	int numer;
	
	if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
		baza[numer] = pobierz_wpis ();
		zapisz_baze ();
	} else {
		ostatni++;
		baza[ostatni] = pobierz_wpis ();
		zapisz_baze ();
	}
	
	gtk_main_quit ();
}


// Wybranie pozycji Informacje o w menu pomoc - wyswietlenie okna window_about
void on_mw_about1_activate(GtkMenuItem * menuitem, gpointer user_data)
{
	GtkWidget *window_about;
	window_about = create_window_about ();
	gtk_widget_show (window_about);
}


// Klikniecie na wybrany dzien w kalendarzu - wczytywanie wpisu
void on_mw_kalendarz_day_selected(GtkCalendar * calendar, gpointer user_data)
{
	typ_data tmp;
	gtk_calendar_get_date (calendar, &tmp.rok, &tmp.miesiac, &tmp.dzien);
	edytuj_wpis (tmp);
}


// Pokazanie okna MainWindow - poczatkowe operacje (wczytanie baz danych, itp)
void on_MainWindow_show (GtkWidget *widget, gpointer user_data)
{
	pobierz_biezaca_date ();
	wczytaj_baze         ();
	wczytaj_plan_lekcji  ();
	wczytaj_wolne_dni    ();
	wczytaj_ustawienia   ();

	int numer;
	if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
		wypelnij_pola (baza[numer]);
	} else {
		wypelnij_pola (czysty_wpis ());
		
		if (sprawdz_dzien_wolny (biezaca_data) == TRUE) {
		} else {
			laduj_przedmioty ();
		}
	}
	
	wpisz_biezaca_date ();
	ostatni = sprawdz_ostatni ();
	wyswietl_najblizszy_sprawdzian ();
	
	printf ("----------------------\n");	
	printf (" GNU Terminarz Ucznia\n");
	printf (" www.gnu-tu.prv.pl\n");
	printf ("----------------------\n\n");
}


// Zamkniecie okna planu lekcji (window_plan_lekcji)
void on_wpl_anuluj_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *window_plan_lekcji = lookup_widget (GTK_WIDGET (button), "window_plan_lekcji");
	gtk_widget_destroy (GTK_WIDGET (window_plan_lekcji));
}


// Zapisanie planu lekcji i zamkniecie okna planu lekcji (window_plan_lekcji)
void on_wpl_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	pobierz_plan_lekcji (GTK_WIDGET (button));
	zapisz_plan_lekcji ();
	
	GtkWidget *window_plan_lekcji = lookup_widget (GTK_WIDGET (button), "window_plan_lekcji");
	gtk_widget_destroy (GTK_WIDGET (window_plan_lekcji));
	
	wczytaj_plan_lekcji ();
}


// Wybranie opcji Ustaw plan lekcji (w menu Ustawienia) - wyswietlenie okna
// planu lekcji (window_plan_lekcji)
void on_ustaw_plan_lekcji1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *window_plan_lekcji = create_window_plan_lekcji ();
	
	wczytaj_plan_lekcji  ();
	wypelnij_plan_lekcji (window_plan_lekcji);
	
	gtk_widget_show (GTK_WIDGET (window_plan_lekcji));
}


// Wybranie opcji wstaw przedmioty z menu wpis - wstawienie przedmiotow z planu
// lekcji
void on_wstaw_przedmioty1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	laduj_przedmioty ();
}


// Wybranie opcji szukaj sprawdzianow z menu Wpis - wszyszukanie najblizszych
// 3 sprawdzianow
void on_szukaj_sprawdzianow1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	szukaj_sprawdzianow ();
}


// Zamkniecie glownego okna (MainWindow)
gboolean on_MainWindow_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	int numer;
	
	if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
		baza[numer] = pobierz_wpis ();
		zapisz_baze ();
		return FALSE;
	} else {
		ostatni++;
		baza[ostatni] = pobierz_wpis ();
		zapisz_baze ();
		return FALSE;
	}
}


// Kliknieto na przycisk wstaw przedmioty - wstawia przedmioty z planu lekcji
void on_mw_wstaw_btn_clicked (GtkButton *button, gpointer user_data)
{
	laduj_przedmioty ();
}


// Kliknieto na przcisk szukaj sprawdzianow - wyszukuje najblizsze sprawdziany
void on_mw_szukaj_btn_clicked (GtkButton *button, gpointer user_data)
{
	szukaj_sprawdzianow ();
}


// Kliknieto na przycisk zamkniecia programu - zakonczenie pracy programu
void on_mw_quit_btn_clicked (GtkButton *button, gpointer user_data)
{
	int numer;
	
	if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
		baza[numer] = pobierz_wpis ();
		zapisz_baze ();
	} else {
		ostatni++;
		baza[ostatni] = pobierz_wpis ();
		zapisz_baze ();
	}
	
	gtk_main_quit ();
}


// Wybrano opcje Preferencje z menu Ustawienia - wyswietlenie okna preferencje
void on_preferencje1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wp_widget = create_window_preferencje ();
	wp_wczytaj_ustawienia ();
	wp_wolne_dni_wypelnij ();
	gtk_widget_show (GTK_WIDGET (wp_widget));
}


void on_wp_dodaj_dzien_wolny_btn_clicked (GtkButton *button, gpointer user_data)
{
	wp_wolne_dni_dodaj_dzien_wolny ();
}


void on_wp_usun_dzien_wolny_clicked (GtkButton *button, gpointer user_data)
{
	wp_wolne_dni_usun_dzien_wolny ();
}


void on_wp_anuluj_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_destroy (GTK_WIDGET (wp_widget));
}


void on_wp_ok_btn_clicked (GtkButton *button, gpointer user_data)
{	
	// Zapisujemy ustawienia
	wp_zapisz_ustawiennia ();
	
	// Zamykamy okno
	gtk_widget_destroy (GTK_WIDGET (wp_widget));
}


void on_wp_wolne_dni_click_column (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	wp_wolne_dni_zaznaczony_zmien (row);
}


void on_wyczysc_pola_przedmiotow1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wyczysc_przedmioty ();
}


void on_wyczysc_pola_przedmiotow_i_ocen1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wyczysc_przedmioty ();
	wyczysc_oceny ();
}


void on_wyczysc_notatki__sprawdziany_i_kartkowki1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wyczysc_pozostale ();
}


void on_wyczysc_wszystko1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wypelnij_pola (czysty_wpis ());
}


void on_dzisiejszy_wpis1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *kalendarz = lookup_widget (GTK_WIDGET (menuitem), "mw_kalendarz");
	typ_data   tmp_data  = data ();
	
	gtk_calendar_select_day (GTK_CALENDAR (kalendarz), tmp_data.dzien);
	gtk_calendar_select_month (GTK_CALENDAR (kalendarz), (tmp_data.miesiac - 1), tmp_data.rok);
}


// Kliknieto przycisk ok w oknie wyboru pliku
void on_wwp_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	char *nazwa_pliku = gtk_file_selection_get_filename (GTK_FILE_SELECTION (wwp_widget));
	
	switch (wwp_czynnosc) {
		case 1: // Wybranie pliku kopii zapasowej
				if (strlen (nazwa_pliku) <= 0) {
					komunikat ("Nie wybrales zadnego pliku !!!");
				} else {
					// Sprawdza czy plik ma rozszerzenie .gz
					char polecenie[200];
					
					if (nazwa_pliku[strlen (nazwa_pliku)] == "z") {
						sprintf (polecenie, "tar -xvvzf ");
					} else {
						sprintf (polecenie, "tar -xvvf ");
					}
					
					strcat (polecenie, nazwa_pliku);
					system ("rm .gnutu --recursive");
					system (polecenie);
					wczytaj_baze ();
					cofnij_modyfikacje ();
					
					komunikat ("Kopia zapasowa została wczytana !");
				}
				break;
	}
	
	wwp_czynnosc = 0;
	gtk_widget_destroy (GTK_WIDGET (wwp_widget));
}


void on_wwp_anuluj_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *wwp = lookup_widget (GTK_WIDGET (button), "window_wybierz_plik");
	gtk_widget_destroy (GTK_WIDGET (wwp));
}


void on_zrob_kopie_zapasowa1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *wkz = create_window_kopia_zapasowa ();
	gtk_widget_show (GTK_WIDGET (wkz));
}


void on_wczytaj_kopie_zapasowa1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wwp_widget = create_window_wybierz_plik ();
	
	wwp_czynnosc = 1;
	gtk_widget_show (GTK_WIDGET (wwp_widget));
}


void on_wkz_anuluj_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *wkz = lookup_widget (GTK_WIDGET (button), "window_kopia_zapasowa");
	gtk_widget_destroy (GTK_WIDGET (wkz));
}


// Tworzenie kopii zapasowej
void on_wkz_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *wkz = lookup_widget (GTK_WIDGET (button), "window_kopia_zapasowa");
	
	GtkWidget *wkz_kompresja = lookup_widget (GTK_WIDGET (wkz), "wkz_kompresja");
	gboolean  kompresja      = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wkz_kompresja));
	
	czas_struct tmp_czas = czas ();
	typ_data    tmp_data = data ();
	
	char polecenie[150];
	
	if (kompresja == TRUE) {
		sprintf (polecenie, "tar -zcvvf gtu-kopia-%d-%d-%d-%d%d%d.tar.gz .gnutu", tmp_data.dzien, tmp_data.miesiac, tmp_data.rok, tmp_czas.godzina, tmp_czas.minuta, tmp_czas.sekunda);
	} else {
		sprintf (polecenie, "tar -cvvf gtu-kopia-%d-%d-%d-%d%d%d.tar .gnutu", tmp_data.dzien, tmp_data.miesiac, tmp_data.rok, tmp_czas.godzina, tmp_czas.minuta, tmp_czas.sekunda);
	}
	
	printf ("Tworzenie kopii zapasowej...\n");
	system (polecenie);
	printf ("Tworzenie kopii zapasowej zakonczone !\n");
	
	gtk_widget_destroy (GTK_WIDGET (wkz));
	
	komunikat ("Kopia zapasowa została utworzona !");
}


void on_mw_cofnij_btn_clicked (GtkButton *button, gpointer user_data)
{
	cofnij_modyfikacje ();
}


void on_cofnij1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	cofnij_modyfikacje ();
}


gboolean on_window_dziennik_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	wn_zapisz_notatke ();
	return FALSE;
}


void on_dziennik1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wd_widget = create_window_dziennik ();
	wn_wczytaj_notatke ();
	gtk_widget_show (GTK_WIDGET (wd_widget));
}

