/***************************************************************************
 *            engine.c
 *  
 *  Sat Feb 21 22:27:09 2004
 *  Copyright (C) 2004  Marcin Krzywonos
 *  e-mail: linman@op.pl
 ****************************************************************************/


#include "engine.h"
#include "interface.h"


// Wczytuje baze danych z wpisami
int wczytaj_baze ()
{
	FILE *plik;
	if ((plik = fopen (".gnutu/dane.gtu", "r")) == NULL) {
		printf ("BLAD: Nie mozna otworzyc pliku bazy danych (dane.gtu) !\n");
	} else {
		int i = 0;
		while (i != 2201) {
			i++;
			
			fread (&baza[i], sizeof (baza[i]), 1, plik);
			
			if (baza[i].data.dzien == 0)
				break;
		}
		
		fclose (plik);
	}
}


// Zapisuje baze danych z wpisami
int zapisz_baze ()
{
	FILE *plik;
	if ((plik = fopen (".gnutu/dane.gtu", "w")) == NULL) {
		printf ("BLAD: Nie mozna zapisac pliku bazy danych (dane.gtu) !\n");
		system ("mkdir .gnutu");
	} else {
		int i = 0;
		while (i != ostatni) {
			i++;
			fwrite (&baza[i], sizeof (baza[i]), 1, plik);
		}
		
		fclose (plik);
	}
}


// Wyszukuje wpis w bazie danch wg. podanej daty
int szukaj_wpis (typ_data data)
{
	int i = 0;
	
	while (i != 2201) {
		i++;
		
		if (baza[i].data.dzien == 0) {
			return 0;
		} else {
			if ((baza[i].data.dzien == data.dzien) & (baza[i].data.miesiac == data.miesiac) & (baza[i].data.rok == data.rok)) {
				return i;
			} else {
				if (i == 2201)
					return 0;
			}
		}
	}
}


// Zwraca numer ostatniego wpisu w bazie danych
int sprawdz_ostatni ()
{
	int i = 0;
	
	while (i != 2201) {
		i++;
	
		if (baza[i].data.dzien == 0) {
			i--;
			return i;
		}
	}
}


// Edytuje wpis o dacie...
int edytuj_wpis (typ_data data)
{
	int numer;
	
	// Zapis starego wpisu...
	if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
		baza[numer] = pobierz_wpis ();
		
		if (char_to_gboolean (ustawienia[0]) == TRUE)
			zapisz_baze ();
	} else {
		ostatni++;
		baza[ostatni] = pobierz_wpis ();
		
		if (char_to_gboolean (ustawienia[0]) == TRUE)
			zapisz_baze ();
	}
	
	// Wczytywanie starego wpisu, lub tworzenie nowego...
	if ((numer = szukaj_wpis (data)) >= 1) {
		wypelnij_pola (baza[numer]);
		pobierz_biezaca_date ();
		
		wpisz_biezaca_date ();
	} else {
		wypelnij_pola (czysty_wpis ());
		pobierz_biezaca_date ();
		
		if (char_to_gboolean (ustawienia[1]) == TRUE) {
			if (sprawdz_dzien_wolny (biezaca_data) == TRUE) {
			} else {
				laduj_przedmioty ();
			}
		}
		
		wpisz_biezaca_date ();
	}
	
	// Wyswietlenie najblizszego sprawdzianu
	wyswietl_najblizszy_sprawdzian ();
}


// Zwraca czysty wpis
wpis_struct czysty_wpis ()
{
	wpis_struct tmp;
	
	strcpy (tmp.sprawdzian,   "");
	strcpy (tmp.kartkowka1,   "");
	strcpy (tmp.kartkowka2,   "");
	strcpy (tmp.notatki,      "");
	strcpy (tmp.przedmiot[1], "");
	strcpy (tmp.przedmiot[2], "");
	strcpy (tmp.przedmiot[3], "");
	strcpy (tmp.przedmiot[4], "");
	strcpy (tmp.przedmiot[5], "");
	strcpy (tmp.przedmiot[6], "");
	strcpy (tmp.przedmiot[7], "");
	strcpy (tmp.przedmiot[8], "");
	strcpy (tmp.oceny[1],     "");
	strcpy (tmp.oceny[2],     "");
	strcpy (tmp.oceny[3],     "");
	strcpy (tmp.oceny[4],     "");
	strcpy (tmp.oceny[5],     "");
	strcpy (tmp.oceny[6],     "");
	strcpy (tmp.oceny[7],     "");
	strcpy (tmp.oceny[8],     "");

	return tmp;
}


// Wczytuje przedmioty z planu lekcji
int laduj_przedmioty ()
{
	int numer_dnia = dzien_tygodnia (biezaca_data);
	numer_dnia--;
	
	if ((numer_dnia >= 0) & (numer_dnia <= 4)) {
		wstaw_przedmioty (numer_dnia);
	}
}


// Wyszujuje najblizsze sprawdziany
int szukaj_sprawdzianow ()
{
	int       i  = 0;
	int       lk = 0;
	char     *spr [3];
	typ_data  daty_spr [3];
	
	while (i != ostatni) {
		i++;
		
		if ((baza[i].data.rok == biezaca_data.rok) &
			(baza[i].data.miesiac <= (biezaca_data.miesiac + 1)) & 
			(baza[i].data.miesiac >= biezaca_data.miesiac) &
			(strlen (baza[i].sprawdzian) >= 2)) {			
			
			if ((baza[i].data.miesiac == biezaca_data.miesiac) &
				(baza[i].data.dzien < biezaca_data.dzien)) {
			} else {
				lk++;
				
				spr[lk]      = baza[i].sprawdzian;
				daty_spr[lk] = baza[i].data;
				
				if (lk == 3) {
					break;
				}

			}
		}
	}

	char tekst[255];
	
	switch (lk) {
		case 1: sprintf (tekst, "Znalezione sprawdziany:\n%d-%d-%d: %s",
						daty_spr[1].dzien, (daty_spr[1].miesiac + 1), daty_spr[1].rok, spr[1]);
				break;
		case 2: sprintf (tekst, "Znalezione sprawdziany:\n%d-%d-%d: %s\n%d-%d-%d: %s",
						daty_spr[1].dzien, (daty_spr[1].miesiac + 1), daty_spr[1].rok, spr[1],
						daty_spr[2].dzien, (daty_spr[2].miesiac + 1), daty_spr[2].rok, spr[2]);
				break;
		case 3: sprintf (tekst, "Znalezione sprawdziany:\n%d-%d-%d: %s\n%d-%d-%d: %s\n%d-%d-%d: %s",
						daty_spr[1].dzien, (daty_spr[1].miesiac + 1), daty_spr[1].rok, spr[1],
						daty_spr[2].dzien, (daty_spr[2].miesiac + 1), daty_spr[2].rok, spr[2],
						daty_spr[3].dzien, (daty_spr[3].miesiac + 1), daty_spr[3].rok, spr[3]);
				break;
		case 0: sprintf (tekst, "Nie znaleziono sprawdzianow !");
				break;
	}

	komunikat (tekst);
}


// Wyswietla najblizszy sprawdzian
void wyswietl_najblizszy_sprawdzian ()
{
	if (char_to_gboolean (ustawienia[2]) == FALSE) {
		char tekst [150];
		sprintf (tekst, "");
		uaktualnij_sprawdzian (tekst);
		
		return 0;
	}
	
	int       i  = 0;
	char     *spr;
	typ_data  data;
	
	while (i != ostatni) {
		i++;
		
		if ((baza[i].data.rok == biezaca_data.rok) &
			(baza[i].data.miesiac <= (biezaca_data.miesiac + 1)) & 
			(baza[i].data.miesiac >= biezaca_data.miesiac) &
			(strlen (baza[i].sprawdzian) >= 2)) {
			
			if ((baza[i].data.miesiac == biezaca_data.miesiac) &
				(baza[i].data.dzien < biezaca_data.dzien)) {
				
				char tekst [150];
				sprintf (tekst, "<b>Najblizszy sprawdzian</b>\nbrak");
				uaktualnij_sprawdzian (tekst);
				
				break;
			} else {
				spr  = baza[i].sprawdzian;
				data = baza[i].data;
				char tekst [150];
				
				if ((baza[i].data.rok == biezaca_data.rok) &
					(baza[i].data.miesiac == biezaca_data.miesiac) &
					((baza[i].data.dzien - biezaca_data.dzien) <= 7)) {
					sprintf (tekst, "<b>Najblizszy sprawdzian\n[%d-%d-%d] %s</b>\n", data.dzien, (data.miesiac + 1), data.rok, spr);
				} else {
					sprintf (tekst, "<b>Najblizszy sprawdzian</b>\n[%d-%d-%d] %s\n", data.dzien, (data.miesiac + 1), data.rok, spr);
				}
				uaktualnij_sprawdzian (tekst);
				
				break;
			}
		} else {
			char tekst [150];
			sprintf (tekst, "<b>Najblizszy sprawdzian</b>\nbrak");
			uaktualnij_sprawdzian (tekst);
		}
	}
}


// Cofa ostatnia modyfikacje
void cofnij_modyfikacje ()
{
	int numer;
	
	if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
		wypelnij_pola (baza[numer]);
		pobierz_biezaca_date ();
		
		wpisz_biezaca_date ();
	} else {
		wypelnij_pola (czysty_wpis ());
		pobierz_biezaca_date ();
		
		if (sprawdz_dzien_wolny (biezaca_data) == TRUE) {
		} else {
			laduj_przedmioty ();
		}
		
		wpisz_biezaca_date ();
	}
	
	// Wyswietlenie najblizszego sprawdzianu
	wyswietl_najblizszy_sprawdzian ();
}


// Zapisuje baze wolne dni
int zapisz_wolne_dni ()
{
	FILE *plik;
	
	if ((plik = fopen (".gnutu/wolne_dni.gtu", "w")) == NULL) {
		printf ("BLAD: Nie mozna utworzyc pliku bazy wolnych dni (wolne_dni.gtu) !\n");
	} else {
		int i = 0;
		
		while (i != 365) {
			if ((wolne_dni[i].dzien == 0) & (wolne_dni[i].miesiac == 0) & (wolne_dni[i].rok == 0)) {
				break;
			} else {
				if ((wolne_dni[i].dzien != 100) & (wolne_dni[i].miesiac != 100) & (wolne_dni[i].rok != 1000)) {
					fwrite (&wolne_dni[i], sizeof (wolne_dni[i]), 1, plik);
				}
			}
			
			i++;
		}
		
		fclose (plik);
	}
	
	wczytaj_wolne_dni ();
}


// Wczytuje baze wolnych dni
int wczytaj_wolne_dni ()
{
	FILE *plik;
	
	if ((plik = fopen (".gnutu/wolne_dni.gtu", "r")) == NULL) {
		printf ("BLAD: Nie mozna otworzyc pliku bazy wolnych dni (wolne_dni.gtu) !\n");
	} else {
		int i = 0;
		
		while (i != 365) {
			fread (&wolne_dni[i], sizeof (wolne_dni[i]), 1, plik);
			
			if ((wolne_dni[i].dzien == 0) & (wolne_dni[i].miesiac == 0) & (wolne_dni[i].rok == 0)) {
				break;
			} else {
			}
			
			i++;
		}
		
		fclose (plik);
	}
}


// Dodaje pozycje do bazy wolnych dni
int wolne_dni_dodaj (typ_data data)
{
	int i = 0;
	while (i != 365) {
		if ((wolne_dni[i].dzien == 0) & (wolne_dni[i].miesiac == 0) & (wolne_dni[i].rok == 0))
			break;
		
		if ((wolne_dni[i].dzien == 100) & (wolne_dni[i].miesiac == 100) & (wolne_dni[i].rok == 10000)) {
			break;
		}
		
		i++;
	}
	
	wolne_dni[i] = data;
}


// Usuwa pozycje w bazie wolnych dni
int wolne_dni_usun (typ_data data)
{
	int i = 0;
	while (i != 365) {
		if ((wolne_dni[i].dzien == 0) & (wolne_dni[i].miesiac == 0) & (wolne_dni[i].rok == 0))
			break;
		
		if ((wolne_dni[i].dzien == data.dzien) & (wolne_dni[i].miesiac == data.miesiac) &
			(wolne_dni[i].rok == data.rok)) {
			wolne_dni[i].dzien   = 100;
			wolne_dni[i].miesiac = 100;
			wolne_dni[i].rok     = 10000;
			break;
		}
		
		i++;
	}
	i++;
}


// Sprawdza czy dzien (data) istnieje w bazie wolne dni
gboolean wolne_dni_istnieje (typ_data data)
{
	int i = 0;
	while (i != 365) {
		if ((wolne_dni[i].dzien == 100) & (wolne_dni[i].miesiac == 100) & (wolne_dni[i].rok == 10000)) {
			return FALSE;
		}
		
		if ((wolne_dni[i].dzien == data.dzien) & (wolne_dni[i].miesiac == data.miesiac) &
			(wolne_dni[i].rok == data.rok)) {
			return TRUE;
		}
		
		i++;
	}
	
	return FALSE;
}


// Sprawdza, czy dzien jest dniem wolnym
gboolean sprawdz_dzien_wolny (typ_data data)
{
	int i = 0;
	
	data.miesiac++;
	
	while (i != 365) {
		if ((wolne_dni[i].dzien == 0) & (wolne_dni[i].miesiac == 0) & (wolne_dni[i].rok == 0)) {
			return FALSE;
		} else {
			if ((wolne_dni[i].dzien != 100) & (wolne_dni[i].miesiac != 100) & (wolne_dni[i].rok != 1000)) {
				if ((wolne_dni[i].dzien == data.dzien) & (wolne_dni[i].miesiac == data.miesiac) & (wolne_dni[i].rok == data.rok)) {
					return TRUE;
				}
			}
		}
		
		i++;
	}
	
	return FALSE;
}


// Zapisuje baze planu lekcji
int zapisz_plan_lekcji ()
{
	FILE *plik;
	
	if ((plik = fopen (".gnutu/plan.gtu", "w")) == NULL) {
		printf ("BLAD: Nie mozna utworzyc pliku planu lekcji (plan.gtu) !\n");
	} else {
		fwrite (&plan, sizeof (plan), 1, plik);
		fclose (plik);
	}
}


// Wczytuje baze planu lekcji
int wczytaj_plan_lekcji ()
{
	FILE *plik;
	
	if ((plik = fopen (".gnutu/plan.gtu", "r")) == NULL) {
		printf ("BLAD: Nie mozna otworzyc pliku planu lekcji (plan.gtu) !\n");
	} else {
		fread (&plan, sizeof (plan), 1, plik);
		fclose (plik);
	}
}


// Oblicza dzien tygodnia (podana jest data)
int dzien_tygodnia (typ_data data)
{
	int miesiac_struct []   = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	data.miesiac ++;
	
	int roznica_dni  = 0;
	int licznik      = 0;

	if (data.rok > 2100) {
		komunikat ("Pewny jesteś, że mamy rok większy od 2100 ?");
	} else {
		while (licznik < (2102 - data.rok)) {
			licznik++;
			
			if (((2103 - licznik) % 4) == 0) {
				roznica_dni += 366;
			} else {
				roznica_dni += 365;
			}
		}
		
		licznik = data.miesiac;
		
		while (licznik < 12) {
			licznik++;
			if ((licznik == 2) & ((data.rok % 4) == 0)) {
				roznica_dni += (miesiac_struct [licznik] + 1);
			} else {
				roznica_dni += miesiac_struct [licznik];
			}
		}
		
		if ((data.miesiac == 2) & ((data.rok % 4) == 0)) {
			roznica_dni += ((miesiac_struct [data.miesiac] + 1) - data.dzien - 1);
		} else {
			roznica_dni += (miesiac_struct [data.miesiac] - data.dzien - 1);
		}
	}
	
	int dzien = 7 - (roznica_dni % 7);

	return dzien;
}
